/******************************************************************************
 *            Copyright (c) 2006 Michel Gutierrez. All Rights Reserved.
 ******************************************************************************/

var DWHelper={
	queue: [],
	current: null,
	KEY_COPYURL: 1,
	KEY_REQCONVERT: 2,
	KEY_QUICK: 3
};

DWHelper.baseMenu=[
	{ 
		label: DWHUtil.getText("menu.preferences"),
		oncommand: "DWHelper_preferences()"
	},
	{ 
		label: DWHUtil.getText("menu.sites"),
		oncommand: "DWHelper_openSites()"
	},
	{ 
		label: DWHUtil.getText("menu.history"),
		oncommand: "DWHelper_openHistory()",
		observes: "dwhelper-history-enabled"
	},
	{ 
		label: DWHUtil.getText("menu.convert-register"),
		oncommand: "DWHelper_convertRegister()",
		observes: "dwhelper-convert-free",
		'class': "menuitem-iconic",
		image: "chrome://dwhelper/skin/converter-12x12.png"
	},
	{ 
		label: DWHUtil.getText("menu.manual-convert"),
		oncommand: "DWHelper_manualConvert()",
		observes: "dwhelper-convert-enabled",
		'class': "menuitem-iconic",
		image: "chrome://dwhelper/skin/converter-12x12.png"
	},
	{ 
		label: DWHUtil.getText("menu.converter-queue"),
		oncommand: "DWHelper_converterQueue()",
		observes: "dwhelper-convert-queue",
		'class': "menuitem-iconic",
		image: "chrome://dwhelper/skin/converter-12x12.png"
	},
	{ 
		label: DWHUtil.getText("menu.download-queue"),
		oncommand: "DWHelper_openDownloadQueue()",
		observes: "dwhelper-isonebyone"
	},
	{ 
		label: DWHUtil.getText("menu.open-download-dir"),
		oncommand: "DWHelper_openDownloadDir()"
	},
	{ 
		label: DWHUtil.getText("menu.help"),
		oncommand: "DWHelper_help()"
	},
	{ 
		label: DWHUtil.getText("menu.knowledge-base"),
		oncommand: "DWHelper_kb()"
	},
	{ 
		label: DWHUtil.getText("menu.tutorial-videos"),
		oncommand: "DWHelper_tutorial_videos()"
	},
	/*
	{ menuseparator: true },
	{ 
		label: DWHUtil.getText("menu.manual-check"),
		oncommand: "DWHelper_manualCheck()"
	},
	*/
	{ 
		label: DWHUtil.getText("menu.convert-register"),
		oncommand: "DWHelper_convertRegister()",
		observes: "dwhelper-convert-free"
	},
	{ menuseparator: true },
	{ 
		label: DWHUtil.getText("menu.subtile.extension"),
		menu: [
			{
				label: DWHUtil.getText("menu.subtile.install"),
				oncommand: "DWHelper_gotoSubtile('dh-st-install')"
			},
			{
				label: DWHUtil.getText("menu.subtile.monitor-video-sites"),
				oncommand: "DWHelper_gotoSubtile('dh-monitor-vsites')"
			},
			{
				label: DWHUtil.getText("menu.subtile.cust-monitor-video-sites"),
				oncommand: "DWHelper_gotoSubtile('dh-st-build')"
			},
			{
				label: DWHUtil.getText("menu.subtile.monitor-extension-review"),
				oncommand: "DWHelper_gotoSubtile('dh-fxext')"
			},
			{
				label: DWHUtil.getText("menu.subtile.create-menu"),
				oncommand: "DWHelper_gotoSubtile('dh-create')"
			},
		]
	},
/*	{ 
		label: DWHUtil.getText("menu.to-sumo"),
		oncommand: "DWHelper_gotoSumo()"
	},*/
	{ menuseparator: true },
	{ 
		label: DWHUtil.getText("menu.about"),
		oncommand: "DWHelper_about()"
	}
];


DWHelper.prefService=Components.classes["@mozilla.org/preferences-service;1"]
	.getService(Components.interfaces.nsIPrefService);
DWHelper.pref=DWHelper.prefService.getBranch("dwhelper.");
DWHelper.listMgr=Components.classes["@downloadhelper.net/media-list-manager"]
	.getService(Components.interfaces.dhIMediaListMgr);
DWHelper.dlMgr=Components.classes["@downloadhelper.net/download-manager;1"]
					.getService(Components.interfaces.dhIDownloadMgr);
DWHelper.convertService = Components.classes["@downloadhelper.net/convert-manager-component"]
		.getService(Components.interfaces.dhIConvertMgr);
DWHelper.util=Components.classes["@downloadhelper.net/util-service;1"]
	.getService(Components.interfaces.dhIUtilService);


// cannot initiate the timer directly as it won't be fired (threading pb ?) 
setTimeout(function() { DWHelper.listMgr.initTimer(); }, 60*1000);

DWHelper.controlers= {
		"youtube": new YouTubeControl(),
		"medialink": new MediaLink(),
		//"mediareq": new MediaReq(),
		"mediaresp": new MediaResp(),
		//"vdown": new VDownControler(),
		//"keepvid": new KeepVidControler(),
		"plugins": new PluginsControler(),
		//"mediaweight": new MediaWeight()
};

DWHelper.version=DWHUtil.getVersion();

window.addEventListener("pageshow",DWHelper_onPageShow,true);
window.addEventListener("pagehide",DWHelper_onPageHide,true);

window.addEventListener("close",DWHelper_onClose,true);

function tabSelected(event)
{
  setTimeout(DWHelper_loadMenu,0,null);
}

function DWHelper_onPageShow(e) {
}

function DWHelper_onPageHide(e) {
	if(window.content!=null && window.content.document==e.originalTarget) {
		DWHelper_disableButton();
		for(var i in DWHelper.controlers) {
			var controler=DWHelper.controlers[i];
			if(controler.reset!=null) {
				try {
					controler.reset();
				} catch(e) {
				}
			}
		}		
	}
}

window.addEventListener("load", DWHelper_onLoad, false);
var firstSessionLaunch=true;

function DWHelper_onLoad(e) {

	if(firstSessionLaunch) {
	
		firstSessionLaunch=false;
		try {
		DWHelper_updateContextMenu();
		DWHelper_updateDownloadQueue();
		DWHelper_updateHistory();
		DWHelper_updateConvert();
		DWHelper_updateConvertFree();
		DWHelper_updateConvertQueue();
		DWHelper_updateKeys();
		DWHelper_updateStatusbar();
		
		var version=DWHUtil.getVersion();
		if(DWHelper.pref.getBoolPref("first-time")) {
			try {
				function welcome(version) {
					try {
						var browser = top.getBrowser();
						browser.selectedTab=browser.addTab("http://www.downloadhelper.net/welcome.php?version="+version);
					} catch(e) {
					}
				}
				setTimeout(welcome,100,version);
			} catch(e) {
			}
			DWHelper.pref.setBoolPref("first-time",false);
			DWHelper.pref.setCharPref("last-version",version);
			DWHelper_install();
		} else {
			var lastVersion="1.95";
			try {
				lastVersion=DWHelper.pref.getCharPref("last-version");
			} catch(e) {}
			if(lastVersion!=version) {
				DWHelper.pref.setCharPref("last-version",version);
				try {
					function install(lastVersion,version,cwe) {
						try {
							var browser = top.getBrowser();
							if(cwe)
								browser.selectedTab=browser.addTab("http://www.downloadhelper.net/update.php?to="+version+"&from="+lastVersion);
							else
								browser.selectedTab=browser.addTab("http://www.downloadhelper.net/update.php?from="+lastVersion+"&to="+version);
						} catch(e) {
						}
					}
					var cwe=false;
					try {
						cwe=DWHelper.pref.getBoolPref("conversion-was-enabled");
					} catch(e) {}
					setTimeout(install,100,lastVersion,version,cwe);
				} catch(e) {}
			}
		}
		} catch(e) {
		}
	}
}


document.addEventListener("DOMContentLoaded", DWHelper_onDomContentLoad, false);


function DWHelper_onDomContentLoad(e) {
	if(e.originalTarget instanceof HTMLDocument) {
		DWHelper_loadMenu(e.originalTarget);
	}
}
	
function DWHelper_loadMenu(doc) {
	if(DWHelper_loadMenu.arguments.length==0)
		doc=null;
	var menuData={children:[]};
	for(var i in DWHelper.controlers) {
		var controler=DWHelper.controlers[i];
		if(controler.updateMenu) {
			try {
				controler.updateMenu(menuData.children,doc);
			} catch(e) {
			}
		}
	}
	if(DWHelper.menupopup)
		DWHUtil.clearMenu(DWHelper.menupopup);
	if(DWHelper.sbmenupopup)
		DWHUtil.clearMenu(DWHelper.sbmenupopup);
	if(DWHelper.bctxMenupopup) {
		DWHUtil.clearMenu(DWHelper.bctxMenupopup);
		DWHUtil.populateMenu(DWHelper.bctxMenupopup,DWHelper.baseMenu);
	}
	if(DWHelper.sbctxMenupopup) {
		DWHUtil.clearMenu(DWHelper.sbctxMenupopup);
		DWHUtil.populateMenu(DWHelper.sbctxMenupopup,DWHelper.baseMenu);
	}
	if(DWHelper.ctxMenupopup) {
		DWHUtil.clearMenu(DWHelper.ctxMenupopup);
		DWHUtil.populateMenu(DWHelper.ctxMenupopup,DWHelper.baseMenu);
	}
	if(DWHelper.toolsMenupopup) {
		DWHUtil.clearMenu(DWHelper.toolsMenupopup);
		DWHUtil.populateMenu(DWHelper.toolsMenupopup,DWHelper.baseMenu);
	}
	
	if(menuData.children.length>0) {
		try {
		var globalMenuData={
			'class': 'menuitem-iconic controler-entry',
			'onmouseover': "DWHelper_menuItemMouseOver(event)",
			'onmouseout': "DWHelper_menuItemMouseOut(event)",
			'oncommand': "DWHelper_menuItemClicked(event)"
		};
		if(DWHelper.ctxMenupopup) {
			DWHUtil.populateMenu(DWHelper.ctxMenupopup,[{menuseparator:true}]);
			DWHUtil.populateMenu(DWHelper.ctxMenupopup,menuData.children,globalMenuData);
		}
		if(DWHelper.toolsMenupopup) {
			DWHUtil.populateMenu(DWHelper.toolsMenupopup,[{menuseparator:true}]);
			DWHUtil.populateMenu(DWHelper.toolsMenupopup,menuData.children,globalMenuData);
		}
		if(DWHelper.menupopup)
			DWHUtil.populateMenu(DWHelper.menupopup,menuData.children,globalMenuData);
		if(DWHelper.sbmenupopup)
			DWHUtil.populateMenu(DWHelper.sbmenupopup,menuData.children,globalMenuData);
		DWHelper_enableButton();
		} catch(e) {
		}
	} else {
		DWHelper_disableButton();
	}
}

function DWHelper_manualCheck() {	
	for(var i in DWHelper.controlers) {
		var controler=DWHelper.controlers[i];
		if(controler.manualCheck) {
			try {
				controler.manualCheck();
			} catch(e) {
			}
		}
	}
}

function DWHelper_gotoSumo() {	
	var browser = top.getBrowser();
	try {
		var w = browser.addTab("http://www.downloadhelper.net/do-goto-sumo.php");
		setTimeout(new Function("b","w","b.selectedTab=w;"),0,browser,w);
	} catch(e) {}
}

function DWHelper_gotoSubtile(where) {	
	var browser = top.getBrowser();
	try {
		var w = browser.addTab("http://www.downloadhelper.net/"+where+".php");
		setTimeout(new Function("b","w","b.selectedTab=w;"),0,browser,w);
	} catch(e) {}
}

function DWHelper_enableButton() {
	if(DWHelper.button) {
		if(DWHelper_isIconAnimated())
			DWHelper.button.setAttribute("class","on toolbarbutton-1 chromeclass-toolbar-additional");
		else
			DWHelper.button.setAttribute("class","on-noanim toolbarbutton-1 chromeclass-toolbar-additional");
		DWHelper.button.setAttribute("type","menu-button");
	}
	if(DWHelper.menupopup)
		DWHelper.menupopup.setAttribute("hidden","false");
	if(DWHelper.sbbutton) {
		if(DWHelper_isIconAnimated())
			DWHelper.sbbutton.setAttribute("class","on toolbarbutton-1 chromeclass-toolbar-additional");
		else
			DWHelper.sbbutton.setAttribute("class","on-noanim toolbarbutton-1 chromeclass-toolbar-additional");
		DWHelper.sbbutton.setAttribute("type","menu-button");
	}
	if(DWHelper.sbmenupopup)
		DWHelper.sbmenupopup.setAttribute("hidden","false");
}

function DWHelper_disableButton() {
	if(DWHelper.button) {
		DWHelper.button.setAttribute("class","off toolbarbutton-1 chromeclass-toolbar-additional");
		//DWHelper.button.removeAttribute("type");
	}
	if(DWHelper.menupopup)
		DWHelper.menupopup.setAttribute("hidden","true");
	if(DWHelper.sbbutton) {
		DWHelper.sbbutton.setAttribute("class","off");
		//DWHelper.sbbutton.removeAttribute("type");
	}
	if(DWHelper.sbmenupopup)
		DWHelper.sbmenupopup.setAttribute("hidden","true");
}

function DWHelper_onLoadOverlay() {

	if(DWHelper.dwCountCookieSet==null) {
		DWHUtil.setDWCountCookie(DWHelper.pref);
		DWHelper.dwCountCookieSet=true;
	}

	if(DWHelper.ytLinksMenuItem==null) {
		var ytLinksMenuItem=document.getElementById("dwhelper-ytlinks");
		if(ytLinksMenuItem!=null) {
			DWHelper.ytLinksMenuItem=ytLinksMenuItem;
			var menu = document.getElementById("contentAreaContextMenu");
  			menu.addEventListener("popupshowing", DWHelper_popupShowing, false);
		}
	}

	if(DWHelper.gBrowser==null && gBrowser!=null) {
		DWHelper.gBrowser=gBrowser;
		var container = gBrowser.mPanelContainer;
		container.addEventListener("select", tabSelected, false);
	}


	if(DWHelper.button==null) {
		DWHelper.button=document.getElementById("dwhelper-button");
		if(DWHelper.button)
			DWHelper.button.removeAttribute("image");
	}
	if(DWHelper.sbbutton==null) {
		DWHelper.sbbutton=document.getElementById("dwhelper-statusbar-button");
		if(DWHelper.sbbutton)
			DWHelper.sbbutton.removeAttribute("image");
	}
	if(DWHelper.menupopup==null)
		DWHelper.menupopup=document.getElementById("dwhelper-menupopup");
	if(DWHelper.sbmenupopup==null)
		DWHelper.sbmenupopup=document.getElementById("dwhelper-statusbar-menupopup");
	if(DWHelper.ctxMenupopup==null) {
		DWHelper.ctxMenupopup=document.getElementById("dwhelper-ctxmenupopup");
		if(DWHelper.ctxMenupopup) {
			DWHUtil.clearMenu(DWHelper.ctxMenupopup);
			DWHUtil.populateMenu(DWHelper.ctxMenupopup,DWHelper.baseMenu);
		}
	}
	if(DWHelper.bctxMenupopup==null) {
		DWHelper.bctxMenupopup=document.getElementById("dwhelper-bctxmenupopup");
		if(DWHelper.bctxMenupopup) {
			DWHUtil.clearMenu(DWHelper.bctxMenupopup);
			DWHUtil.populateMenu(DWHelper.bctxMenupopup,DWHelper.baseMenu);
		}
	}
	if(DWHelper.sbctxMenupopup==null) {
		DWHelper.sbctxMenupopup=document.getElementById("dwhelper-sbctxmenupopup");
		if(DWHelper.sbctxMenupopup) {
			DWHUtil.clearMenu(DWHelper.sbctxMenupopup);
			DWHUtil.populateMenu(DWHelper.sbctxMenupopup,DWHelper.baseMenu);
		}
	}
	if(DWHelper.toolsMenupopup==null) {
		DWHelper.toolsMenupopup=document.getElementById("dwhelper-toolsmenupopup");
		if(DWHelper.toolsMenupopup) {
			DWHUtil.clearMenu(DWHelper.toolsMenupopup);
			DWHUtil.populateMenu(DWHelper.toolsMenupopup,DWHelper.baseMenu);
		}
	}
	
	//if(DWHelper.saveFilePicker==null) {
		DWHelper.saveFilePicker=Components.classes["@mozilla.org/filepicker;1"]
	           .createInstance(Components.interfaces.nsIFilePicker);
		DWHelper.saveFilePicker.init(window, DWHUtil.getText("title.save-file"), 
			Components.interfaces.nsIFilePicker.modeSave);
 		var dir=DWHelper.dlMgr.getMainDir();
 		DWHelper.saveFilePicker.displayDirectory=dir;
		DWHelper.saveFilePicker.appendFilter("All Files","*.*");
	//}

}

function DWHelper_getControlerDataFromEvent(e) {
	var menuitem=e.originalTarget;
	var controlerName=menuitem.getAttribute("controler");
	var value=menuitem.getAttribute("value");
	var system=menuitem.getAttribute("system");
	
	var controler=null;
	if(controlerName!=null)
		controler=DWHelper.controlers[controlerName];
	return {
		controler: controler,
		value: value,
		system: system
	}
}

function DWHelper_about() {
    var options="chrome,centerscreen,modal";
    var data={};
    window.openDialog('chrome://dwhelper/content/about.xul','dwhelper-dialog',options, 
 		data);
 	if(data.knowMore)
 		content.location.href="http://www.downloadhelper.net/";

}

function DWHelper_help() {
	content.location.href="http://www.downloadhelper.net/manual.php";
}

function DWHelper_kb() {
	content.location.href="http://www.downloadhelper.net/support-kb.php";
}

function DWHelper_tutorial_videos() {
	content.location.href="http://www.downloadhelper.net/tutorials.php";
}

function DWHelper_convertRegister() {
    var options="chrome,centerscreen,modal";
    var data={};
    window.openDialog('chrome://dwhelper/content/convert-register.xul','dwhelper-dialog',options, 
 		data);
 	if(data.getConvertCode)
 		content.location.href="http://convert.downloadhelper.net/";
}


function DWHelper_showHttp() {
    var options="chrome";
    window.open('chrome://dwhelper/content/showhttp.xul','dwhelper-showhttp',options, 
    	{} );	
}

function DWHelper_preferences() {
    var options="chrome,centerscreen,modal";
    window.openDialog('chrome://dwhelper/content/preferences.xul','dwhelper-dialog',options, 
    	{} );
}

function DWHelper_buttonClicked(e) {
	if(DWHelper.button || DWHelper.sbbutton) {
		if(/.*toolbarbutton$/.test(e.originalTarget.tagName))
			DWHelper_openSites();
	}
}

function DWHelper_openSites() {
	var w=window.open("chrome://dwhelper/content/sites.xul",
                 "dwhelper-sites", "chrome,centerscreen,resizable=yes");
    w.focus();
}

function DWHelper_openHistory() {
	var w=window.open("chrome://dwhelper/content/history.xul",
                 "dwhelper-history", "chrome,centerscreen,resizable=yes");
    w.focus();
}

function DWHelper_converterQueue() {
	var w=window.open("chrome://dwhelper/content/converter-queue.xul",
                 "dwhelper-convert-queue", "chrome,centerscreen,resizable=yes");
    w.focus();
}

function DWHelper_askFormat(format) {
	var data={
		format: format
	};
	window.openDialog("chrome://dwhelper/content/convert-manual.xul",
                 "dwhelper-convert-manual", "chrome,centerscreen,modal",data);
    if(data.format==null) {
    	return null;
    }
    return data.format;
}

function DWHelper_manualConvert() {

	var filePicker=Components.classes["@mozilla.org/filepicker;1"]
           .createInstance(Components.interfaces.nsIFilePicker);
	filePicker.init(window, DWHUtil.getText("title.files-to-convert"), 
		Components.interfaces.nsIFilePicker.modeOpenMultiple);
	var dir=DWHelper.dlMgr.getMainDir();
	filePicker.displayDirectory=dir;
	filePicker.appendFilter("FLV","*.flv; *.FLV");
	filePicker.appendFilter("Video","*.flv; *.FLV; *.avi; *.AVI; *.mpeg; *.MPEG; *.mpg; *.MPG; *.wmv; *.WMV; *.rm; *.RM; *.mov; *.MOV; *.mp4; *.MP4");
	filePicker.appendFilters(Components.interfaces.nsIFilePicker.filterAll);
	var r=filePicker.show();
	if(r==Components.interfaces.nsIFilePicker.returnCancel)
		return;
		
	var format=DWHelper_askFormat(null);
	if(format==null)
		return;

	var convertMgr=Components.classes["@downloadhelper.net/convert-manager-component"]
        .getService(Components.interfaces.dhIConvertMgr);
        
	var i=filePicker.files;
	while(i.hasMoreElements()) {
		var file=i.getNext().QueryInterface(Components.interfaces.nsIFile);
		var targetFile=file.parent;
		targetFile.append(DWHelper_getConvertedFileName(file.leafName,format));
		convertMgr.addConvert(file,targetFile,format,false);
	}
}

function DWHelper_openDownloadQueue() {
	var w=window.open("chrome://dwhelper/content/download-queue.xul",
                 "dwhelper-download-queue", "chrome,centerscreen,resizable=yes");
    w.focus();
}

function DWHelper_openDownloadDir() {
	try {
		var dir=DWHelper.dlMgr.getMainDir().QueryInterface(Components.interfaces.nsILocalFile);
		dir.reveal();
	} catch(e) {
	}
}

function DWHelper_menuItemClicked(e) {

	if(e.originalTarget.nodeName=="menuitem") {
		var controlerData=DWHelper_getControlerDataFromEvent(e);
		if(controlerData.controler) {
			var key=(e.ctrlKey?1:0)+(e.shiftKey?2:0);
			controlerData.controler.download(controlerData.value,key);
		} else if(controlerData.system=="about") {
			DWHelper_about();
		}
	} else {
		DWHelper_about();
	}
	
}

function DWHelper_menuItemMouseOver(e) {
	var controlerData=DWHelper_getControlerDataFromEvent(e);
	if(controlerData.controler && controlerData.controler.mouseOver)
		controlerData.controler.mouseOver(controlerData.value);
}

function DWHelper_menuItemMouseOut(e) {
	var controlerData=DWHelper_getControlerDataFromEvent(e);
	if(controlerData.controler && controlerData.controler.mouseOut)
		controlerData.controler.mouseOut(controlerData.value);
}

function DWHelper_downloadFileAs(fileName,url,pageUrl,format) {
	//dump("DWHelper_downloadFileAs("+fileName+","+url+","+pageUrl+","+format+")\n");
	var fileName0=DWHelper_getConvertedFileName(fileName,format);
	var localFile=DWHelper.saveFilePicker.displayDirectory.clone();
    localFile.append(fileName0);
    try {
    	localFile.createUnique(Components.interfaces.nsIFile.FILE_TYPE, 0644);
    } catch(e) {
    	localFile=DWHelper.dlMgr.getMainDir();
	    localFile.append(fileName0);
    	localFile.createUnique(Components.interfaces.nsIFile.FILE_TYPE, 0644);
    }
    
    fileName0=localFile.leafName;
    localFile.remove(false);
    
	DWHelper.saveFilePicker.displayDirectory=localFile.parent;
	DWHelper.saveFilePicker.defaultString=fileName0;
	
	var rs=DWHelper.saveFilePicker.show();
	if(rs==Components.interfaces.nsIFilePicker.returnCancel) {
		return;
	}
	var p=DWHelper.saveFilePicker.file.parent;
	if(p!=null) {
		DWHelper.saveFilePicker.displayDirectory=p.clone();
		DWHelper.util.setUnicharPref(DWHelper.pref,"storagedirectory",p.path);
	}
	if(!DWHelper.saveFilePicker.file.exists()) {
		DWHelper.saveFilePicker.file.create(Components.interfaces.nsIFile.FILE_TYPE, 0644);
	}
	
	DWHelper_downloadFileTo(DWHelper.saveFilePicker.file,url,null,pageUrl,fileName,format);
}

function DWHelper_downloadFileBlind(fileName,url,pageUrl,orgFileName,format) {
	var localFile=DWHelper.saveFilePicker.displayDirectory.clone();
    localFile.append(DWHelper_getConvertedFileName(fileName,format));
    try {
    	localFile.createUnique(Components.interfaces.nsIFile.FILE_TYPE, 0644);
    } catch(e) {
    	localFile=DWHelper.dlMgr.getMainDir();
	    localFile.append(fileName);
    	localFile.createUnique(Components.interfaces.nsIFile.FILE_TYPE, 0644);
    }
    
	DWHelper_downloadFileTo(localFile,url,null,pageUrl,orgFileName,format);
}

function DWHelper_downloadFileQuick(fileName,url,pageUrl,format) {
	var extension=DWHelper_getFileExtension(fileName);
	fileName=DWHelper_getConvertedFileName(fileName,format);
	var mainDir=DWHelper.dlMgr.getMainDir();
	var file=mainDir.clone();
	file.append(fileName);
   	file.createUnique(Components.interfaces.nsIFile.FILE_TYPE, 0644);
   	fileName=DWHelper_setFileExtension(file.leafName,extension);
	DWHelper_downloadFile(null,file.leafName,url,pageUrl,format);
}

function DWHelper_downloadFile(dirName,fileName,url,pageUrl,format) {
	//dump("DWHelper_downloadFile("+dirName+","+fileName+","+url+","+pageUrl+","+format+")\n");
	var mainDir=DWHelper.dlMgr.getMainDir();
	var dwDir=mainDir.clone();
	if(dirName!=null) {
		dirName=dirName.replace(/[^a-zA-Z0-9\.\-]/g,"_");
		dwDir.append(dirName);
	}
	var downloadMode=DWHUtil.getDownloadMode(DWHelper.pref);
	var file=dwDir.clone();
	if(downloadMode!="flashgot") {
		if(!dwDir.exists()) {
			dwDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0775);
		}
		file.append(DWHelper_getConvertedFileName(fileName,format));
		DWHelper_downloadFileTo(file,url,null,pageUrl,fileName,format);
	} else {
		file.append(fileName);
		DWHelper_downloadFileTo(file,url,null,pageUrl,fileName,null);
	}
}

function DWHelper_downloadFileTo(file,url,referer,pageUrl,orgFileName,format) {
	//dump("DWHelper_downloadFileTo("+file.path+","+url+","+pageUrl+","+format+")\n");
	if(DWHelper_downloadFileTo.arguments.length<3)
		referer=null;
	if(DWHelper_downloadFileTo.arguments.length<4)
		pageUrl=null;
    var localFile=Components.classes["@mozilla.org/file/local;1"].
        createInstance(Components.interfaces.nsILocalFile);
    localFile.initWithPath(file.path);

    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var target=ioService.newFileURI(localFile);

    var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    uri.spec = url;
    
    var puri = null;
    if(pageUrl!=null) {
    	var puri=Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    	puri.spec=pageUrl;
    }

	var downloadMode=DWHUtil.getDownloadMode(DWHelper.pref);
	var flashGot=null;
	if(downloadMode=="flashgot") {
		flashGot=DWHUtil.getFlashGot();
		if(flashGot==null || typeof(gFlashGot)=="undefined")
			downloadMode="onebyone";
	}
	switch(downloadMode) {
		case "onebyone":
			DWHelper.dlMgr.addDownload(uri,localFile,false,referer, true, puri,orgFileName,format);
			break;
		case "normal":
			DWHelper.dlMgr.doDownload(uri,localFile,false,referer, true, puri,orgFileName,format);
			break;
		case "flashgot":
			var link={
				href: url,
				description: ""
			}
			gFlashGot.download([link],gFlashGotService.OP_ONE,null);
			break;
	}
}

function DWHelper_getUniqueDir(dirname) {
	var mainDir=DWHelper.dlMgr.getMainDir();
	var dir=mainDir.clone();
	dir.append(dirname);
	if(!dir.exists())
		return dirname;
	var dirParts=/^(.*?)(?:\-([0-9]+))?$/.exec(dirname);
	var baseName=dirParts[1];
	var index=dirParts[2];
	if(index==null)
		index=1;
	while(true) {
		dir=mainDir.clone();
		dirname=baseName+"-"+index;
		dir.append(dirname);
		if(!dir.exists())
			return dirname;
		index++;
	}
}

function DWHelper_getUniqueFile(dirname,filename) {
	filename=filename.replace(/[^a-zA-Z0-9\.\- _]/g,"");
	var maxlen=64;
	if(filename.length>maxlen) {
		var fileParts=/^(.*?)(\.[a-zA-Z0-9]+)?$/.exec(filename);
		var suffix=fileParts[2];
		if(suffix==null)
			filename=fileParts[1].substring(0,maxlen);
		else
			filename=fileParts[1].substring(0,maxlen-suffix.length)+suffix;
	}
	var mainDir=DWHelper.dlMgr.getMainDir();
	var dir=mainDir.clone();
	dir.append(dirname);
	if(!dir.exists())
		return filename;
	var fileParts=/^(.*?)(?:\-([0-9]+))?(\.[a-zA-Z0-9]+)?$/.exec(filename);
	var baseName=fileParts[1];
	var index=fileParts[2];
	if(index==null)
		index=1;
	var suffix=fileParts[3];
	if(suffix==null)
		suffix="";
	while(true) {
		var file=dir.clone();
		filename=baseName+"-"+index+suffix;
		file.append(filename);
		if(!file.exists())
			return filename;
		index++;
	}
}

var prefBranch2=DWHelper.pref.QueryInterface(Components.interfaces.nsIPrefBranch2);
var prefObserver={
	observe: function(subject,topic,data) {
		if(topic=="nsPref:changed") {
			if(data=="context-menu")
				DWHelper_updateContextMenu();
			if(data=="download-mode")
				DWHelper_updateDownloadQueue();
			if(data=="history-enabled")
				DWHelper_updateHistory();
			if(data=="convert-free")
				DWHelper_updateConvertFree();
			if(data=="conversion-enabled") {
				DWHelper_updateConvert();
				DWHelper_updateConvertQueue();
			}
			if(data=="quickkey.key" || data=="quickkey.modifier" || data=="opendirkey.key" || data=="opendirkey.modifier")
				DWHelper_updateKeys();
			if(data=="show-in-statusbar")
				DWHelper_updateStatusbar();
		}
	}
}
prefBranch2.addObserver("", prefObserver, false);

var observerService =
	Components.classes["@mozilla.org/observer-service;1"]
    	.getService(Components.interfaces.nsIObserverService);

var reqObserver = {
	prefBranch2: prefBranch2,
	prefObserver: prefObserver,
	observerService: observerService,
	observe: function(subject,topic,data) {
		if(topic=="http-on-modify-request") {
			if (typeof Components == 'undefined')
				return;
		    var channel=subject.QueryInterface(Components.interfaces.nsIHttpChannel);
			if(channel.requestMethod!="GET")
				return;
		    var request=subject.QueryInterface(Components.interfaces.nsIRequest);
		    if(DWHelper.listMgr.checkCurrentURL(request.name))
				return;
		    if(DWHelper.current==null || DWHelper.current.url!=request.name) {
				for(var i in DWHelper.controlers) {
					var controler=DWHelper.controlers[i];
					if(controler.newRequest!=null) {
						try {
							controler.newRequest(request.name,request);
						} catch(e) {
						}
					}
				}
			} 
		} else if(topic=="http-on-examine-response") {
			if (typeof Components == 'undefined')
				return;
		    var request=subject.QueryInterface(Components.interfaces.nsIRequest);
		    if(DWHelper.listMgr.checkCurrentURL(request.name))
				return;
			try {
			    var channel=subject.QueryInterface(Components.interfaces.nsIHttpChannel);
			    var location=channel.getResponseHeader("Location");
			    if(location!=null && DWHelper.current) {
			    	DWHelper.current.url=location;
			    }
			} catch(e) {}
		    if(DWHelper.current==null || DWHelper.current.url!=request.name) {
				for(var i in DWHelper.controlers) {
					var controler=DWHelper.controlers[i];
					if(controler.newResponse!=null) {
						try {
							controler.newResponse(subject);
						} catch(e) {
						}
					}
				}
			} 
		} 
	}
};	
observerService.addObserver(reqObserver,"http-on-modify-request",false);
observerService.addObserver(reqObserver,"http-on-examine-response",false);

function DWHelper_onClose(event) {
	try { observerService.removeObserver(reqObserver,"http-on-modify-request"); } catch(e) {}
	try { observerService.removeObserver(reqObserver,"http-on-examine-response"); } catch(e) {}
	try { prefBranch2.removeObserver("",prefObserver); } catch(e) {}
}

function DWHelper_install() {
	try {
		DWHelper.pref.clearUserPref("alert-update");
	} catch(e) {
	}
	try {
		var dwhelperId="dwhelper-toolbaritem";
		var afterId="urlbar-container";
		var afterElem=document.getElementById(afterId);
		if(afterElem) {
			var navBar=afterElem.parentNode;
			if(document.getElementById(dwhelperId)==null) {
				// waiting for firefox bug 403959 to be solved
				//navBar.insertItem(dwhelperId,afterElem.nextSibling);
				navBar.insertItem(dwhelperId,afterElem);
				navBar.setAttribute("currentset", navBar.currentSet );
				document.persist("nav-bar", "currentset");
			}
		}		
	} catch(e) {
	}
}

DWHelper_getMenuHttpExpiration=function() {
	var expiration=60000;
	try {
		expiration=DWHelper.pref.getIntPref("menu-http-expiration");
	} catch(e) {
	}
	return expiration;
}

DWHelper_isIconAnimated=function() {
	var ia=true;
	try {
		ia=DWHelper.pref.getBoolPref("icon-animation");
	} catch(e) {
	}
	return ia;
}

DWHelper_getPopupNode=function(wnd) {
	var popupNode=wnd.document.popupNode;
	if(popupNode)
		return popupNode;
	for(var i=0;i<wnd.frames.length;i++) {
		var frame=wnd.frames[i];
		popupNode=DWHelper_getPopupNode(frame);
		if(popupNode!=null)
			return popupNode;
	}
	return popupNode;
}

DWHelper_popupShowing=function(event) {
	var ytlinksEnabled=false;
	try {
		ytlinksEnabled=DWHelper.pref.getBoolPref("ytlinks-enabled");
	} catch(e) {
	}
	if(ytlinksEnabled)
		YTLinks.popupShowing();
}

DWHelper_canChooseName=function() {
	if(DWHUtil.getDownloadMode(DWHelper.pref)=="flashgot")
		return false;
	else 
		return true;
}

DWHelper_updateContextMenu=function() {
	try {
	var show=true;
	try {
		show=DWHelper.pref.getBoolPref("context-menu");
	} catch(e) {}
	if(show) {
		document.getElementById("dwhelper-ctxmenu").setAttribute("hidden","false");
	} else {
		document.getElementById("dwhelper-ctxmenu").setAttribute("hidden","true");
	}
	} catch(e) { }
}

DWHelper_updateDownloadQueue=function() {
	try {
	var mode="onebyone";
	try {
		mode=DWHelper.pref.getCharPref("download-mode");
	} catch(e) {}
	var bc=document.getElementById("dwhelper-isonebyone");
	if(bc!=null) {
		var hide=(mode=="onebyone")?"false":"true";
		bc.setAttribute("hidden",hide);
	}
	} catch(e) { }
}

DWHelper_updateHistory=function() {
	try {
	var he=false;
	try {
		he=DWHelper.pref.getBoolPref("history-enabled");
	} catch(e) {}
	var bc=document.getElementById("dwhelper-history-enabled");
	if(bc!=null) {
		bc.setAttribute("hidden",""+!he);
	}
	} catch(e) { }
}

DWHelper_isConverterEnabled=function() {
	var ce=false;
	try {
		ce=DWHelper.pref.getBoolPref("conversion-enabled");
	} catch(e) {}
	return ce;
}

DWHelper_updateConvert=function() {
	var ce=DWHelper_isConverterEnabled();
	if(ce) {
		DWHelper.pref.setBoolPref("conversion-was-enabled",true);
	}
	var bc=document.getElementById("dwhelper-convert-enabled");
	if(bc!=null) {
		bc.setAttribute("hidden",""+!ce);
	}
}

DWHelper_updateConvertFree=function() {
	var cf=false;
	if(DWHelper_isConverterEnabled()) {
		try {
			cf=DWHelper.pref.getBoolPref("convert-free");
		} catch(e) {}
	}
	var bc=document.getElementById("dwhelper-convert-free");
	if(bc!=null) {
		bc.setAttribute("hidden",""+!cf);
	}
}

DWHelper_updateConvertQueue=function() {

	var convertMgr=Components.classes["@downloadhelper.net/convert-manager-component"]
        .getService(Components.interfaces.dhIConvertMgr);

	var bc=document.getElementById("dwhelper-convert-queue");
	if(DWHelper_isConverterEnabled()) {
		bc.setAttribute("hidden","false");
	} else {
		bc.setAttribute("hidden","true");
	}
}

DWHelper_getDefaultFormat=function(filename,pageUrl,mediaUrl) {
	var downloadMode=DWHUtil.getDownloadMode(DWHelper.pref);
	if(downloadMode=="flashgot")
		return null;
	var format=DWHelper.convertService.getFormat(filename,pageUrl,mediaUrl);
	return format;
}

DWHelper_getConvertedFileName=function(filename,format) {
	return DWHelper_setFileExtension(
		filename,
		DWHelper_getFormatExtension(format)
	);
}

DWHelper_getFileExtension=function(filename) {
	if(/^.+\..+$/.test(filename))
		return /^.+\.(.+?)$/.exec(filename)[1];
	else 
		return null;
}

DWHelper_setFileExtension=function(filename,extension) {
	if(extension!=null) {
		if(/^.+\..+$/.test(filename)) {
			return /^(.+\.).+?$/.exec(filename)[1]+extension;
		} else {
			return filename+"."+extension;
		}
	} else {
		return filename;
	}
}

DWHelper_getFormatExtension=function(format) {
	if(format!=null && /^.+\/.*/.test(format))
		return /^(.+?)\/.*$/.exec(format)[1];
	else 
		return null;
}

DWHelper_QuickKey=function() {
	var wwatch = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService().
		QueryInterface(Components.interfaces.nsIWindowWatcher);
	var aWindow=wwatch.activeWindow;
	if(aWindow==null || aWindow.content==null || aWindow.content.document==null || aWindow.content.document.URL==null)
		return;
	var url=aWindow.content.document.URL;
	var hitFound=false;
	for(var i in DWHelper.controlers) {
		var controler=DWHelper.controlers[i];
		if(controler.quickDownload!=null) {
			try {
				hitFound=controler.quickDownload(url);
			} catch(e) {
			}
		}
		if(hitFound)
			break;
	}
	if(!hitFound) {
		alert(DWHUtil.getText("error.quickkey.nohit"));
	}
}

DWHelper_updateKeys=function() {
	function updateKey(defKey,defModifier,keyElemId,prefName) {
		var key=defKey;
		try {
			key=DWHelper.pref.getCharPref(prefName+".key");
		} catch(e) {}
		if(!/^VK_/.test(key))
			key="VK_"+key;
		var modifier=defModifier;
		try {
			modifier=DWHelper.pref.getCharPref(prefName+".modifier");
		} catch(e) {}
	
		var keyElem=document.getElementById(keyElemId);
		if(keyElem) {
			if(/^VK_.$/.test(key)) {
				var m=/^VK_(.)$/.exec(key);
				keyElem.removeAttribute("keycode");
				keyElem.setAttribute("key",m[1]);
			} else {
				keyElem.removeAttribute("key");
				keyElem.setAttribute("keycode",key);
			}
			keyElem.setAttribute("modifiers",modifier);
		}
	}
	updateKey("VK_Q","control shift","dwhelper-quick-key","quickkey");
	updateKey("VK_O","control shift","dwhelper-opendir-key","opendirkey");
}

DWHelper_updateStatusbar=function() {
	var isb=false;
	try {
		isb=DWHelper.pref.getBoolPref("show-in-statusbar");
	} catch(e) {}
	document.getElementById("dwhelper-statusbarpanel").setAttribute("hidden",""+!isb);
}
