/******************************************************************************
 *            Copyright (c) 2006 Michel Gutierrez. All Rights Reserved.
 ******************************************************************************/

function YouTubeControl() {
	this.hqChecker={};
}

YouTubeControl.prototype.getDataFromPage=function(doc) {
	if(/^http:\/\/[^\/]*\.?youtube\.[^\/\.]+/.test(doc.URL)) {
		var dom=doc.documentElement;
		var scripts=DWHUtil.xpGetStrings(dom,".//script/text()");
		var videoId=null;
		var t=null;
		for(var i=0;i<scripts.length;i++) {
			var script=scripts[i];
			var match=/video_id=([^&]+)(?:&.*)&t=([^&]+)/m.exec(script);
			if(match!=null && match.length==3) {
				videoId=match[1];
				t=match[2];
				break;
			}
			var match=/[&\?]t=(.*?)&.*video_id=(.*?)(?:&|")/m.exec(script);
			if(match!=null && match.length==3) {
				videoId=match[2];
				t=match[1];
				break;
			}
		}
		if(videoId==null || t==null) {
			var embeds=DWHUtil.xpGetStrings(dom,".//embed/@src");
			for(var i=0;i<embeds.length;i++) {
				var embed=embeds[i];
				var match=/video_id=(.*?)&.*t=(.*?)(?:&|")/m.exec(embed);
				if(match!=null && match.length==3) {
					videoId=match[1];
					t=match[2];
					break;
				}
			}
			if(videoId==null || t==null) {
				return null;
			}
		}
		var title=DWHUtil.xpGetString(dom,"/html/head/meta[@name='title']/@content");
		var format=DWHelper_getDefaultFormat("youtube-video.flv","http://www.youtube.com/youtube-video.flv",doc.URL);
		return {
			videoId: videoId,
			tParam: t,
			title: title,
			pageUrl: doc.URL,
			format: format
		}
	} else {
		return null;
	}
}

YouTubeControl.prototype.dataToValue=function(data,quality) {
	var value=data.videoId+"|"+data.tParam+"|"+data.title+"|"+data.pageUrl+"|";
	if(data.format)
		value+=data.format;
	value+="|"+quality;
	return value;
}

YouTubeControl.prototype.hqCheck=function(args,docUrl) {
	if(this.hqChecker.pageUrl==docUrl) {
		if(args.format) {
			this.hqChecker.hqFormat=args.format;
			DWHelper_loadMenu(null);
		}
	}
}

YouTubeControl.prototype.updateMenu=function(menu,doc) {
	try {
		if(doc==null)
			doc=content.document;
		if(doc.URL==this.hqChecker.pageUrl) {
			if(this.hqChecker.data) {
				menu.push({label:this.hqChecker.data.title, src:"http://www.youtube.com/favicon.ico",
					value: this.dataToValue(this.hqChecker.data,"0"), controler: "youtube" });
				if(this.hqChecker.hqFormat!=0)
					menu.push({label:DWHUtil.getText("label.high-quality-prefix")+" "+this.hqChecker.data.title, src:"http://www.youtube.com/favicon.ico",
						value: this.dataToValue(this.hqChecker.data,this.hqChecker.hqFormat), controler: "youtube" });
			}
		} else {
			var data=this.getDataFromPage(doc);
			this.hqChecker={
				pageUrl: doc.URL,
				data: data,
				hqFormat: 0
			}
			if(data!=null) {
				menu.push({label:data.title, src:"http://www.youtube.com/favicon.ico",
					value: this.dataToValue(data,"lq"), controler: "youtube" });
				var doCheckHQ=true;
				try {
					doCheckHQ=DWHelper.pref.getBoolPref("yt-check-hq");		
				} catch(e) {}
				if(doCheckHQ) {
					function hqCheck(context,args) {
						context._this.hqCheck(args,context.docUrl);
					}
					try {
						var videoUrl="http://www.youtube.com/get_video?video_id=";
						videoUrl+=data.videoId;
						videoUrl+="&t=";
						videoUrl+=data.tParam;
						new YTHQChecker(videoUrl,hqCheck,{ _this: this, docUrl: doc.URL }).check();
					} catch(e) {
						dump("!!! [YoutubeControl] Checker exception: "+e+"\n");
					}
				}
			}
		}
	} catch(e) { }
}

YouTubeControl.prototype.download=function(value,key) {
	var url="http://www.youtube.com/get_video?video_id=";
	var values=value.split("|");
	url+=values[0];
	url+="&t=";
	url+=values[1];
	var title=values[2];
	var pageUrl=values[3];
	var format=null;
	if(values[4].length>0)
		format=values[4];
	if(values[5]!="0")
		url+="&fmt="+values[5];
	var fileName=title+".flv";
	var unmodifiedFilename=false;
	try {
		unmodifiedFilename=DWHelper.pref.getBoolPref("yt-unmodified-filename");		
	} catch(e) {}
	if(unmodifiedFilename==false) {
		var keepSpaces=false;
		try {
			keepSpaces=DWHelper.pref.getBoolPref("yt-keep-spaces");
		} catch(e) {}
		if(keepSpaces)
			fileName=fileName.replace(/[^a-zA-Z0-9\.\- ]/g,"_");
		else
			fileName=fileName.replace(/[^a-zA-Z0-9\.\-]/g,"_");
	} else {
		fileName=fileName.replace(/[\/"]/g,"_");
	}
	
	if(key==DWHelper.KEY_COPYURL) {
		DWHUtil.toClipboard(url);
	} else {
		if(key==DWHelper.KEY_REQCONVERT && DWHelper_isConverterEnabled()) {
			format=DWHelper_askFormat(format);
		}
		if(DWHelper_canChooseName()) {
			try {
				if(key==DWHelper.KEY_QUICK) {
					DWHelper_downloadFileQuick(fileName,url,pageUrl,format);
				} else {
					DWHelper_downloadFileAs(fileName,url,pageUrl,format);
				}
			} catch(e) {}
		} else {
			try {
				DWHelper_downloadFile("youtube",fileName,url,pageUrl,format);
			} catch(e) { }
		}
	}
	
}
